#include "usart1.h"

/*
USART1 is the Bluetooth usart, through which the robot receives its commands from the Bluetooth master. 
*/


//when a new packet is received, this variable will be set to 1
volatile unsigned char new_packet = 0;
//character arrived from bluetooth
volatile unsigned char newchar;



//////////////////////////////////////////////////////////////////////////////////////////////////////

FILE usart1 = FDEV_SETUP_STREAM(usart1_putchar, usart1_getchar, _FDEV_SETUP_RW);

//////////////////////////////////////////////////////////////////////////////////////////////////////


//if an interrupt occurs during the initialisation period of the lbuetooth it will be ignored
volatile unsigned char bluetooth_initing = 0;


int usart1_getchar(FILE *stream) 	//wait for the char to be received and then return it
{
	loop_until_bit_is_set(UCSR1A,RXC);
	return UDR1;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////

int usart1_putchar(char c, FILE *stream)
{
	//(bluetooth_initing == 0 && !bluetooth_connection_established())return 0;
	
	if(c=='\n')usart1_putchar('\r',NULL);
	loop_until_bit_is_set(UCSR1A, UDRE);
	UDR1 = c;
	return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////

/*
THe buffer structure
0123456789 10

0 - !
1 - robot name
2 - command
3,4,5,6 - parameters
7,8 - checksum
9,10 - \n or \r or \r\n
*/

ISR(USART1_RX_vect)
{
	newchar = usart1_getchar(0);
	new_packet = 1;
	return;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////

/*
The output vector
*/

ISR(USART1_TX_vect)
{
	return;
}



//////////////////////////////////////////////////////////////////////////////////////////////////////
void reset_bluetooth(void)
{
	cbi(PORTD,4);
	wait(1000);
	sbi(PORTD,4);

	return;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////


